Adding bash and time to list of hosttools
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils time
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet time
87 bash"
88
89 # directories to be built in a cross environment only
90 #
91 cross_only="target-libiberty target-libgloss target-newlib"
92
93 ## All tools belong in one of the four categories, and are assigned above
94 ## We assign ${configdirs} this way to remove all embedded newlines. This
95 ## is important because configure will choke if they ever get through.
96 ## ${configdirs} is directories we build using the host tools.
97 ## ${target_configdirs} is directories we build using the target tools.
98 #
99 configdirs=`echo ${host_libs} ${host_tools}`
100 target_configdirs=`echo ${target_libs} ${target_tools}`
101
102 ################################################################################
103
104 srctrigger=move-if-change
105 srcname="gnu development package"
106
107 # This gets set non-empty for some net releases of packages.
108 appdirs=""
109
110 # per-host:
111
112 # Work in distributions that contain no compiler tools, like Autoconf.
113 if [ -d ${srcdir}/config ]; then
114 case "${host}" in
115 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
116 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
117 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
118 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
119 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
120 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
121 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
122 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
123 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
124 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
125 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
126 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
127 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
128 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
129 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
130 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
131 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
132 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
133 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
134 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
135 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
136 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
137 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
138 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
139 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
140 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
141 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
142 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
143 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
144 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
145 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
146 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
147 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
148 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
149 esac
150 fi
151
152 # If we aren't going to be using gcc, see if we can extract a definition
153 # of CC from the fragment.
154 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
155 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
156 found=
157 for dir in $PATH; do
158 test -z "$dir" && dir=.
159 if test -f $dir/gcc; then
160 found=yes
161 break
162 fi
163 done
164 IFS="$save_ifs"
165 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
166 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
167 if [ -n "${xx}" ] ; then
168 CC=$xx
169 fi
170 fi
171 fi
172
173 # We default to --with-shared on platforms where -fpic is meaningless.
174 # Well, we don't yet, but we will.
175 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
176 case "${target}" in
177 alpha-dec-osf*) enable_shared=yes ;;
178 alpha-*-linux*) enable_shared=yes ;;
179 mips-sgi-irix5*) enable_shared=yes ;;
180 *) enable_shared=no ;;
181 esac
182 fi
183
184 case "${enable_shared}" in
185 yes) shared=yes ;;
186 no) shared=no ;;
187 "") shared=no ;;
188 *) shared=yes ;;
189 esac
190
191 if [ x${shared} = xyes ]; then
192 waugh=
193 case "${host}" in
194 hppa*) waugh=config/mh-papic ;;
195 i[345]86-*) waugh=config/mh-x86pic ;;
196 sparc64-*) waugh=config/mh-sparcpic ;;
197 *) waugh=config/mh-${host_cpu}pic ;;
198 esac
199 if [ -f ${srcdir}/${waugh} ]; then
200 if [ -n "${host_makefile_frag}" ] ; then
201 cat ${srcdir}/${host_makefile_frag} > mh-frag
202 cat ${srcdir}/${waugh} >> mh-frag
203 host_makefile_frag=mh-frag
204 else
205 host_makefile_frag=${waugh}
206 fi
207 fi
208 fi
209
210 # per-target:
211
212 case "${target}" in
213 v810*) target_makefile_frag=config/mt-v810 ;;
214 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
215 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
216 esac
217
218 skipdirs=
219 gasdir=gas
220 use_gnu_ld=
221 use_gnu_as=
222
223 # some tools are so dependent upon X11 that if we're not building with X,
224 # it's not even worth trying to configure, much less build, that tool.
225
226 case ${with_x} in
227 yes | "") # the default value for this tree is that X11 is available
228 ;;
229 no)
230 skipdirs="${skipdirs} tk gash"
231 ;;
232 *)
233 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
234 ;;
235 esac
236
237 # Some tools are only suitable for building in a "native" situation.
238 # Those are added when we have a host==target configuration. For cross
239 # toolchains, we add some directories that should only be useful in a
240 # cross-compiler.
241
242 is_cross_compiler=
243
244 if [ x"${host}" = x"${target}" ] ; then
245 # when doing a native toolchain, don't build the targets
246 # that are in the 'cross only' list
247 skipdirs="${skipdirs} ${cross_only}"
248 is_cross_compiler=no
249 target_subdir=.
250 else
251 # similarly, don't build the targets in the 'native only'
252 # list when building a cross compiler
253 skipdirs="${skipdirs} ${native_only}"
254 is_cross_compiler=yes
255 target_subdir=${target_alias}
256 if [ ! -d ${target_subdir} ] ; then
257 if mkdir ${target_subdir} ; then true
258 else
259 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
260 exit 1
261 fi
262 fi
263 fi
264
265 copy_dirs=
266
267 # Handle --with-headers=XXX. The contents of the named directory are
268 # copied to $(tooldir)/sys-include.
269 if [ x"${with_headers}" != x ]; then
270 if [ x${is_cross_compiler} = xno ]; then
271 echo 1>&2 '***' --with-headers is only supported when cross compiling
272 exit 1
273 fi
274 case "${exec_prefixoption}" in
275 "") x=${prefix} ;;
276 *) x=${exec_prefix} ;;
277 esac
278 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
279 fi
280
281 # Handle --with-libs=XXX. Multiple directories are permitted. The
282 # contents are copied to $(tooldir)/lib.
283 if [ x"${with_libs}" != x ]; then
284 if [ x${is_cross_compiler} = xno ]; then
285 echo 1>&2 '***' --with-libs is only supported when cross compiling
286 exit 1
287 fi
288 # Copy the libraries in reverse order, so that files in the first named
289 # library override files in subsequent libraries.
290 case "${exec_prefixoption}" in
291 "") x=${prefix} ;;
292 *) x=${exec_prefix} ;;
293 esac
294 for l in ${with_libs}; do
295 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
296 done
297 fi
298
299 # If both --with-headers and --with-libs are specified, default to
300 # --without-newlib.
301 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
302 if [ x"${with_newlib}" = x ]; then
303 with_newlib=no
304 fi
305 fi
306
307 # Recognize --with-newlib/--without-newlib.
308 if [ x${with_newlib} = xno ]; then
309 skipdirs="${skipdirs} target-newlib"
310 elif [ x${with_newlib} = xyes ]; then
311 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
312 fi
313
314 # Default to using --with-stabs for certain targets.
315 if [ x${with_stabs} = x ]; then
316 case "${target}" in
317 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
318 with_stabs=yes;
319 withoptions="${withoptions} --with-stabs"
320 ;;
321 esac
322 fi
323
324 # Handle ${copy_dirs}
325 set fnord ${copy_dirs}
326 shift
327 while [ $# != 0 ]; do
328 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
329 :
330 else
331 echo Copying $1 to $2
332
333 # Use the install script to create the directory and all required
334 # parent directories.
335 if [ -d $2 ]; then
336 :
337 else
338 echo >config.temp
339 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
340 fi
341
342 # Copy the directory, assuming we have tar.
343 # FIXME: Should we use B in the second tar? Not all systems support it.
344 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
345
346 # It is the responsibility of the user to correctly adjust all
347 # symlinks. If somebody can figure out how to handle them correctly
348 # here, feel free to add the code.
349
350 echo $1 > $2/COPIED
351 fi
352 shift; shift
353 done
354
355 # Configure extra directories which are host specific
356
357 case "${host}" in
358 i[345]86-*-go32*)
359 configdirs="$configdirs dosrel" ;;
360 *-cygwin32*)
361 configdirs="$configdirs dosrel" ;;
362 esac
363
364 # Remove more programs from consideration, based on the host or
365 # target this usually means that a port of the program doesn't
366 # exist yet.
367
368 noconfigdirs=""
369
370 case "${host}" in
371 i[345]86-*-vsta)
372 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
373 ;;
374 i[345]86-*-go32)
375 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
376 ;;
377 *-*-cygwin32)
378 noconfigdirs="tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
379 ;;
380 ppc*-*-pe)
381 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
382 ;;
383 esac
384
385
386 case "${target}" in
387 *-*-netware)
388 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
389 ;;
390 *-*-vxworks*)
391 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
392 ;;
393 *-*-ose)
394 noconfigdirs="$noconfigdirs target-libgloss"
395 ;;
396 alpha-dec-osf*)
397 # ld works, but does not support shared libraries. emacs doesn't
398 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
399 # gas doesn't generate exception information.
400 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
401 ;;
402 alpha*-*-*vms*)
403 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
404 ;;
405 alpha*-*-*)
406 # newlib is not 64 bit ready
407 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
408 ;;
409 # start-sanitize-arc
410 arc-*-*)
411 noconfigdirs="$noconfigdirs target-libgloss"
412 ;;
413 # end-sanitize-arc
414 arm-*-pe*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 arm-*-riscix*)
418 noconfigdirs="$noconfigdirs ld target-libgloss"
419 ;;
420 h8300*-*-* | \
421 h8500-*-*)
422 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
423 ;;
424 hppa*-*-*elf* | \
425 hppa*-*-lites*)
426 # Do configure ld/binutils/gas for this case.
427 ;;
428 hppa*-*-*)
429 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
430 # cc is gcc, and on any system a user should be able to link cc to
431 # whatever they want. FIXME, emacs emacs19).
432 case "${CC}" in
433 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
434 *) ;;
435 esac
436 noconfigdirs="$noconfigdirs ld shellutils"
437 ;;
438 i[345]86-*-go32)
439 # but don't build gdb
440 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
441 ;;
442 *-*-cygwin32)
443 target_configdirs="$target_configdirs target-winsup"
444 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
445 # always build newlib.
446 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
447
448 # Can't build gdb for cygwin32 if not native.
449 case "${host}" in
450 *-*-cygwin32) ;; # keep gdb
451 *) noconfigdirs="$noconfigdirs gdb"
452 esac
453 ;;
454 i[345]86-*-pe)
455 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
456 ;;
457 i[345]86-*-sco3.2v5*)
458 # The linker does not yet know about weak symbols in COFF,
459 # and is not configured to handle mixed ELF and COFF.
460 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
461 ;;
462 i[345]86-*-sco*)
463 noconfigdirs="$noconfigdirs gprof target-libgloss"
464 ;;
465 i[345]86-*-solaris2*)
466 # The linker does static linking correctly, but the Solaris C library
467 # has bugs such that some important functions won't work when statically
468 # linked. (See man pages for getpwuid, for example.)
469 noconfigdirs="$noconfigdirs ld target-libgloss"
470 ;;
471 i[345]86-*-sysv4*)
472 # The SYSV4 C compiler doesn't handle Emacs correctly
473 case "${CC}" in
474 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
475 *) ;;
476 esac
477 # but that's okay since emacs doesn't work anyway
478 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
479 ;;
480 powerpc-*-aix*)
481 # copied from rs6000-*-* entry
482 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
483 # This is needed until gcc and ld are fixed to work together.
484 use_gnu_ld=no
485 ;;
486 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
487 target_configdirs="$target_configdirs target-winsup"
488 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
489 # always build newlib.
490 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
491 ;;
492 # This is temporary until we can link against shared libraries
493 powerpcle-*-solaris*)
494 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
495 ;;
496 rs6000-*-lynxos*)
497 # The CVS server code doesn't work on the RS/6000
498 # Newlib makes problems for libg++ in crosses.
499 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
500 ;;
501 rs6000-*-aix*)
502 noconfigdirs="$noconfigdirs gprof"
503 # This is needed until gcc and ld are fixed to work together.
504 use_gnu_ld=no
505 ;;
506 rs6000-*-*)
507 noconfigdirs="$noconfigdirs gprof"
508 ;;
509 m68k-apollo-*)
510 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
511 ;;
512 mips*-*-irix5*)
513 # The GNU linker does not support shared libraries.
514 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
515 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
516 ;;
517 mips*-*-irix6*)
518 # The GNU linker does not support shared libraries.
519 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
520 # BFD does not have Irix 6 support yet.
521 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
522 ;;
523 mips*-dec-bsd*)
524 noconfigdirs="$noconfigdirs gprof target-libgloss"
525 ;;
526 mips*-*-bsd*)
527 noconfigdirs="$noconfigdirs gprof target-libgloss"
528 ;;
529 mips*-*-*)
530 noconfigdirs="$noconfigdirs gprof"
531 ;;
532 romp-*-*)
533 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
534 ;;
535 sh-*-*)
536 case "${host}" in
537 i[345]86-*-vsta) ;; # don't add gprof back in
538 i[345]86-*-go32) ;; # don't add gprof back in
539 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
540 esac
541 noconfigdirs="$noconfigdirs target-libgloss"
542 ;;
543 sparc-*-sunos4*)
544 if [ x${is_cross_compiler} != xno ] ; then
545 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
546 else
547 use_gnu_ld=no
548 fi
549 ;;
550 v810-*-*)
551 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
552 ;;
553 vax-*-vms)
554 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
555 ;;
556 vax-*-*)
557 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
558 ;;
559 *-*-lynxos*)
560 # Newlib makes problems for libg++ in crosses.
561 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
562 ;;
563 *-*-macos* | \
564 *-*-mpw*)
565 # Macs want a resource compiler.
566 configdirs="$configdirs grez"
567 ;;
568 esac
569
570 # targets that need a second pass
571 case "${target}" in
572 *-gm-magic*)
573 noconfigdirs="$noconfigdirs target-libgloss"
574 ;;
575 esac
576
577 # If we aren't building newlib, then don't build libgloss, since libgloss
578 # depends upon some newlib header files.
579 case "${noconfigdirs}" in
580 *target-libgloss*) ;;
581 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
582 esac
583
584 # If we are building a Canadian Cross, discard tools that can not be built
585 # using a cross compiler. FIXME: These tools should be fixed.
586 if [ "${build}" != "${host}" ]; then
587 noconfigdirs="$noconfigdirs tcl tk expect dejagnu texinfo"
588 fi
589
590 # Make sure we don't let GNU ld be added if we didn't want it.
591 if [ x$with_gnu_ld = xno ]; then
592 use_gnu_ld=no
593 noconfigdirs="$noconfigdirs ld"
594 fi
595
596 # Make sure we don't let GNU as be added if we didn't want it.
597 if [ x$with_gnu_as = xno ]; then
598 use_gnu_as=no
599 noconfigdirs="$noconfigdirs gas"
600 fi
601
602 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
603 # $target_configdirs.
604 # If we have the source for $noconfigdirs entries, add them to $notsupp.
605
606 notsupp=""
607 for dir in . $skipdirs $noconfigdirs ; do
608 dirname=`echo $dir | sed -e s/target-//g`
609 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
610 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
611 if [ -r $srcdir/$dirname/configure ] \
612 || [ -r $srcdir/$dirname/configure.in ]; then
613 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
614 true
615 else
616 notsupp="$notsupp $dir"
617 fi
618 fi
619 fi
620 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
621 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
622 if [ -r $srcdir/$dirname/configure ] \
623 || [ -r $srcdir/$dirname/configure.in ]; then
624 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
625 true
626 else
627 notsupp="$notsupp $dir"
628 fi
629 fi
630 fi
631 done
632
633 # Sometimes the tools are distributed with libiberty but with no other
634 # libraries. In that case, we don't want to build target-libiberty.
635 if [ -n "${target_configdirs}" ]; then
636 others=
637 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
638 if [ "$i" != "libiberty" ]; then
639 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
640 others=yes;
641 break;
642 fi
643 fi
644 done
645 if [ -z "${others}" ]; then
646 target_configdirs=
647 fi
648 fi
649
650 # Deconfigure all subdirectories, in case we are changing the
651 # configuration from one where a subdirectory is supported to one where it
652 # is not.
653 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
654 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
655 rm -f $i/Makefile
656 done
657 fi
658 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
659 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
660 rm -f ${target_subdir}/$i/Makefile
661 done
662 fi
663
664 # Produce a warning message for the subdirs we can't configure.
665 # This isn't especially interesting in the Cygnus tree, but in the individual
666 # FSF releases, it's important to let people know when their machine isn't
667 # supported by the one or two programs in a package.
668
669 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
670 # If $appdirs is non-empty, at least one of those directories must still
671 # be configured, or we error out. (E.g., if the gas release supports a
672 # specified target in some subdirs but not the gas subdir, we shouldn't
673 # pretend that all is well.)
674 if [ -n "$appdirs" ]; then
675 for dir in $appdirs ; do
676 if [ -r $dir/Makefile.in ]; then
677 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
678 appdirs=""
679 break
680 fi
681 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
682 appdirs=""
683 break
684 fi
685 fi
686 done
687 if [ -n "$appdirs" ]; then
688 echo "*** This configuration is not supported by this package." 1>&2
689 exit 1
690 fi
691 fi
692 # Okay, some application will build, or we don't care to check. Still
693 # notify of subdirs not getting built.
694 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
695 echo " ${notsupp}" 1>&2
696 echo " (Any other directories should still work fine.)" 1>&2
697 fi
698
699 # Set with_gnu_as and with_gnu_ld as appropriate.
700 #
701 # This is done by determining whether or not the appropriate directory
702 # is available, and by checking whether or not specific configurations
703 # have requested that this magic not happen.
704 #
705 # The command line options always override the explicit settings in
706 # configure.in, and the settings in configure.in override this magic.
707 #
708 # If the default for a toolchain is to use GNU as and ld, and you don't
709 # want to do that, then you should use the --without-gnu-as and
710 # --without-gnu-ld options for the configure script.
711
712 if [ x${use_gnu_as} = x ] ; then
713 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
714 with_gnu_as=yes
715 withoptions="$withoptions --with-gnu-as"
716 fi
717 fi
718
719 if [ x${use_gnu_ld} = x ] ; then
720 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
721 with_gnu_ld=yes
722 withoptions="$withoptions --with-gnu-ld"
723 fi
724 fi
725
726 if [ x${shared} = xyes ]; then
727 case "${target}" in
728 hppa*) target_makefile_frag=config/mt-papic ;;
729 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
730 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
731 esac
732 fi
733
734 # post-target:
735
736 # Make sure that the compiler is able to generate an executable. If it
737 # can't, we are probably in trouble. We don't care whether we can run the
738 # executable--we might be using a cross compiler--we only care whether it
739 # can be created. At this point the main configure script has set CC.
740 echo "int main () { return 0; }" > conftest.c
741 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
742 if [ $? = 0 ] && [ -s conftest ]; then
743 :
744 else
745 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
746 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
747 rm -f conftest*
748 exit 1
749 fi
750 rm -f conftest*
751
752 # The Solaris /usr/ucb/cc compiler does not appear to work.
753 case "${host}" in
754 sparc-sun-solaris2*)
755 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
756 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
757 could_use=
758 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
759 if [ -d /opt/cygnus/bin ] ; then
760 if [ "$could_use" = "" ] ; then
761 could_use="/opt/cygnus/bin"
762 else
763 could_use="$could_use or /opt/cygnus/bin"
764 fi
765 fi
766 if [ "$could_use" = "" ] ; then
767 echo "Warning: compilation may fail because you're using"
768 echo "/usr/ucb/cc. You should change your PATH or CC "
769 echo "variable and rerun configure."
770 else
771 echo "Warning: compilation may fail because you're using"
772 echo "/usr/ucb/cc, when you should use the C compiler from"
773 echo "$could_use. You should change your"
774 echo "PATH or CC variable and rerun configure."
775 fi
776 fi
777 ;;
778 esac
779
780 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
781 # binutils tools will find libbfd.so.
782 if [ "${shared}" = "yes" ]; then
783 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
784 Makefile > Makefile.tem
785 rm -f Makefile
786 mv -f Makefile.tem Makefile
787
788 case "${host}" in
789 *-*-hpux*)
790 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
791 Makefile > Makefile.tem
792 rm -f Makefile
793 mv -f Makefile.tem Makefile
794 ;;
795 esac
796 fi
797
798 # Record target_configdirs and the configure arguments in Makefile.
799 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
800 targargs=`echo "${arguments}" | \
801 sed -e 's/--norecursion//' \
802 -e 's/--cache[a-z-]*=[^ ]*//' \
803 -e 's/--ho[a-z-]*=[^ ]*//' \
804 -e 's/--ta[a-z-]*=[^ ]*//'`
805
806 # Passing a --with-cross-host argument lets the target libraries know
807 # whether they are being built with a cross-compiler or being built
808 # native. However, it would be better to use other mechanisms to make the
809 # sorts of decisions they want to make on this basis. Please consider
810 # this option to be deprecated. FIXME.
811 if [ x${is_cross_compiler} = xyes ]; then
812 targargs="--with-cross-host=${host_alias} ${targargs}"
813 fi
814
815 targargs="--host=${target_alias} ${targargs}"
816 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
817 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
818 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
819 Makefile > Makefile.tem
820 rm -f Makefile
821 mv -f Makefile.tem Makefile
822
823 #
824 # Local Variables:
825 # fill-column: 131
826 # End:
827 #
This page took 0.066974 seconds and 5 git commands to generate.